ryax-workflow-details-layout([header]="layoutHeader", [graph]="layoutGraph", [tools]="layoutTools")

ng-template(#layoutHeader)
  ryax-workflow-details-header(*ngIf="workflow$ | async as workflow", [workflow]="workflow", [workflowPortals]="getWorkflowPortals$(workflow.id) | async",
    (refresh)="onRefresh()", (deploy)="onDeploy()", (stop)="onStop()", (copy)="onCopy()", (edit)="onEdit()",
    (delete)="onDelete()", (export)="onExport()", (showModal)="showModal()")

ng-template(#layoutGraph)
  ryax-workflow-details-graph([loading]="loading$ | async", [activeWorkflowModuleId]="activeWorkflowModuleId$ | async",
    [workflow]="workflow$ | async", [workflowModules]="workflowModules$ | async", [workflowModuleLinks]="workflowModuleLinks$ | async",
    (selectPane)="onSelectPane()", (openWarnings)="onOpenWarningsTool()",
    (selectNode)="onSelectNode($event)", (addNode)="onAddNode($event)", (moveNode)="onMoveNode($event)", (deleteNode)="onDeleteNode($event)",
    (addEdge)="onAddEdge($event)", (deleteEdge)="onDeleteEdge($event)")

ng-template(#layoutTools)
  ryax-editor-tools([workflow]="workflow$ | async", [activeTool]="activeTool$ | async", [activeWorkflowModuleId]="activeWorkflowModuleId$ | async",
    [moduleStoreToolContent]="moduleStoreToolContent", [moduleSetupToolContent]="moduleSetupToolContent", [warningsToolContent]="warningsToolContent", [workflowErrors]="workflowErrors$ | async",
    (selectTool)="onActiveTool($event)", (contentOpened)="onOpenedToolItem($event)")

ng-template(#moduleStoreToolContent)
  ryax-store-catalog()

ng-template(#moduleSetupToolContent)
  ryax-workflow-details-setup([informations]="toolSetupInformations", [inputs]="toolSetupInputs", [outputs]="toolSetupOutputs", [properties]="toolSetupProperties")

ng-template(#toolSetupInformations)
  ryax-module-informations-setup([workflowModule]="activeWorkflowModule$ | async", [versions]="activeWorkflowModuleVersions$ | async", (save)="onUpdateModuleVersion($event)")

ng-template(#toolSetupInputs)
  ryax-module-input-setup-list([loading]="loadingInputs$ | async", [workflowModuleInputs]="activeWorkflowModuleInputs$ | async",
    [itemTemplate]="toolSteupInputsItem")

ng-template(#toolSteupInputsItem, let-workflowModuleInput)
  ryax-module-input-setup-item([workflowModules]="workflowModules$ | async",
    [workflowModule]="activeWorkflowModule$ | async",
    [workflowModuleInput]="workflowModuleInput",
    [workflowModuleOutputs]="workflowModulesOutputs$ | async",
    [searchWorkflowModuleOutputsIds]="searchWorkflowModuleOutputsIds$ | async",
    (save)="onSaveWorkflowModuleInputSetup($event)", (search)="onSearchWorkflowModulesOutputs($event)", (delete)="deleteFile($event)")

ng-template(#toolSetupOutputs)
  ryax-module-output-setup-list(
    [loading]="loadingOutputs$ | async", [workflowModule]="activeWorkflowModule$ | async", [workflowModuleOutputs]="activeWorkflowModuleOutputs$ | async", [itemTemplate]="toolSetupOutputsItem",
    (addOutput)="onAddWorkflowModuleOutput()")

ng-template(#toolSetupOutputsItem, let-workflowModuleOutput)
  ryax-module-output-setup-item([workflowModule]="activeWorkflowModule$ | async", [workflowModuleOutput]="workflowModuleOutput",
  (save)="onUpdateWorkflowModuleOutput($event)", (delete)="onDeleteWorkflowModuleOutput($event)")

ng-template(#toolSetupProperties)
  ryax-module-properties-setup([workflowModule]="activeWorkflowModule$ | async", (save)="onSaveWorkflowModulePropertiesSetup($event)")

ng-template(#warningsToolContent)
  ryax-workflow-warnings([loading]="loadingWorkflowErrors$ | async", [workflowModules]="workflowModules$ | async", [workflowErrors]="workflowErrors$ | async")

ryax-workflow-delete-modal([visible]="deleteModalVisible$ | async", [workflow]="workflow$ | async",
  (valid)="validateDeleteWorkflow()", (cancel)="cancelDeleteWorkflow()")

ryax-workflow-export-modal([visible]="exportModalVisible$ | async", [exportLoading]="exportLoading$ | async")
